#!/usr/bin/perl

################################################
# Script Copyright 2002 Lawrence Goetz         #
# http://www.lawrencegoetz.com/                #
# goetz@lawrencegoetz.com                      #
################################################

################################################
# Make your changes here!

# Set to the path for location libraries.
#use lib " ";

# Your mail program.
$MAILPROG="/usr/lib/sendmail";

# Your encode program.
$ENCODE="/usr/bin/uuencode";

# Date program.
$DATE="/usr/bin/date";

# Default Subject.
$SUBJECT_DEFAULT="Signature";

# Default Filename.
$FILENAME_DEFAULT="signature.jpg";

# Allowed referers. Set this to your sites name and IP. Include a list of various
# sites you which to allow access to the script.
@referers = ('www.com','0.0.0.0');
################################################

$allowed=0;

# Check the referer to see if it's on the list.
    if ($ENV{'HTTP_REFERER'}) {
        foreach $referer (@referers) {
            if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
        	$allowed=1;   
	     	last;
            }
        }
    }

# It's not on the list, so give an error message.
    if($allowed==0) {
        print ("Content-type: text/html\n\n");
        print ("Access to this script is not allowed, sorry.");
        exit;
    }

use GD;

use CGI qw/:standard/;

# Image dimensions.
$width=param('width');
$height=param('height');

if($width==undef || $height==undef) {
	print ("Content-type: text/html\n\n");
	print ("Image size wrong");
	die 'image size errr';
}

# Email to mail to
$mailto=param('mailto');

unless ($mailto =~ /^[\w.+-]+\@[\w.+-]+$/) {
	print ("Content-type: text/html\n\n");
	print 'The TO address is not valid.';
	die 'email address error';
}

# Email from
$email=param('email');

unless ($email =~ /^[\w.+-]+\@[\w.+-]+$/) {
	print ("Content-type: text/html\n\n");
	print 'The FROM address is not valid.';
	die 'email address error';
}

# Name from
$name=param('name');

# Filename for the image.
$filename=param('filename');
if($filename eq "") {
	$filename=$FILENAME_DEFAULT;
}

# The subject of the email.
$subject=param('subject');
if($subject eq "") {
	$subject=$SUBJECT_DEFAULT;
}

# Create the image.
$im = new GD::Image($width,$height) || die 'image error';


# allocate white
$white = $im->colorAllocate(255, 255, 255);


# allocate black
$black = $im->colorAllocate(0, 0, 0);

# Get the points.
$_=param('signature');
if($_==undef){
	print ("Content-type: text/html\n\n");
	print 'Nothing is drawn.';
	die 'no drawing';
}

# Set binary mode.
binmode STDOUT;

# Make a temp image on disk.
# Get the date:
$filetimestamp=`$DATE '+%H:%M:%S'`;
chomp($filetimestamp);
$tempimage="/tmp/tempimage.$filetimestamp.$$";
open (image, ">$tempimage");
print image $im->jpeg();
close image;

# Encode the image for mailing.
@lines=`$ENCODE $filename < $tempimage`;

# Remove the temporary image.
unlink $tempimage;

# Get the date:
$date=`$DATE '+%A %d %B %Y %H:%M:%S %Z'`;

# Mail the image.
open(MAIL,"|$MAILPROG -t");

# Headers.
print MAIL "To: $mailto\n";
print MAIL "From: $name <$email>\n";
print MAIL "Date: $date";
print MAIL "Subject: $subject\n";

# Separates headers from message.
print MAIL "\n";

print MAIL "Machine $ENV{'REMOTE_ADDR'} sent the following...\n\n";

# The encoded image.
foreach $line (@lines) {
        print MAIL $line;
}

close MAIL;

# Page to visit when done.
$done=param('done');

# Redirect to a page when done.
if($done ne ""){
	print "Location: $done\n\n";
}

else {
	print ("Content-type: text/html\n\n");
	print 'It appears that you have all the files setup in order to use Goetz\'s Signature Applet.<P> You should receive an email with a blank image. If so, all is perfect. <P>';
	print 'If you\'d like to order the full version, please fill out an <A HREF="http://www.lawrencegoetz.com/programs/signature/order.html">Order Form</A>';
}
exit;